/// <reference types="node" />
import * as web3 from '@safecoin/web3.js';
import * as beet from '@metaplex-foundation/beet';
import * as beetSolana from '@j0nnyboi/beet-safecoin';
import { Key } from '../types/Key';
export type MetadataDelegateRecordArgs = {
    key: Key;
    bump: number;
    mint: web3.PublicKey;
    delegate: web3.PublicKey;
    updateAuthority: web3.PublicKey;
};
export declare class MetadataDelegateRecord implements MetadataDelegateRecordArgs {
    readonly key: Key;
    readonly bump: number;
    readonly mint: web3.PublicKey;
    readonly delegate: web3.PublicKey;
    readonly updateAuthority: web3.PublicKey;
    private constructor();
    static fromArgs(args: MetadataDelegateRecordArgs): MetadataDelegateRecord;
    static fromAccountInfo(accountInfo: web3.AccountInfo<Buffer>, offset?: number): [MetadataDelegateRecord, number];
    static fromAccountAddress(connection: web3.Connection, address: web3.PublicKey, commitmentOrConfig?: web3.Commitment | web3.GetAccountInfoConfig): Promise<MetadataDelegateRecord>;
    static gpaBuilder(programId?: web3.PublicKey): beetSolana.GpaBuilder<{
        key: any;
        bump: any;
        updateAuthority: any;
        mint: any;
        delegate: any;
    }>;
    static deserialize(buf: Buffer, offset?: number): [MetadataDelegateRecord, number];
    serialize(): [Buffer, number];
    static get byteSize(): number;
    static getMinimumBalanceForRentExemption(connection: web3.Connection, commitment?: web3.Commitment): Promise<number>;
    static hasCorrectByteSize(buf: Buffer, offset?: number): boolean;
    pretty(): {
        key: string;
        bump: number;
        mint: string;
        delegate: string;
        updateAuthority: string;
    };
}
export declare const metadataDelegateRecordBeet: beet.BeetStruct<MetadataDelegateRecord, MetadataDelegateRecordArgs>;
