import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { BurnArgs } from '../types/BurnArgs';
export type BurnInstructionArgs = {
    burnArgs: BurnArgs;
};
export declare const BurnStruct: beet.FixableBeetArgsStruct<BurnInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type BurnInstructionAccounts = {
    authority: web3.PublicKey;
    collectionMetadata?: web3.PublicKey;
    metadata: web3.PublicKey;
    edition?: web3.PublicKey;
    mint: web3.PublicKey;
    token: web3.PublicKey;
    masterEdition?: web3.PublicKey;
    masterEditionMint?: web3.PublicKey;
    masterEditionToken?: web3.PublicKey;
    editionMarker?: web3.PublicKey;
    tokenRecord?: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    sysvarInstructions: web3.PublicKey;
    splTokenProgram: web3.PublicKey;
};
export declare const burnInstructionDiscriminator = 41;
export declare function createBurnInstruction(accounts: BurnInstructionAccounts, args: BurnInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
