import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { DelegateArgs } from '../types/DelegateArgs';
export type DelegateInstructionArgs = {
    delegateArgs: DelegateArgs;
};
export declare const DelegateStruct: beet.FixableBeetArgsStruct<DelegateInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type DelegateInstructionAccounts = {
    delegateRecord?: web3.PublicKey;
    delegate: web3.PublicKey;
    metadata: web3.PublicKey;
    masterEdition?: web3.PublicKey;
    tokenRecord?: web3.PublicKey;
    mint: web3.PublicKey;
    token?: web3.PublicKey;
    authority: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    sysvarInstructions: web3.PublicKey;
    splTokenProgram?: web3.PublicKey;
    authorizationRulesProgram?: web3.PublicKey;
    authorizationRules?: web3.PublicKey;
};
export declare const delegateInstructionDiscriminator = 44;
export declare function createDelegateInstruction(accounts: DelegateInstructionAccounts, args: DelegateInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
