import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { LockArgs } from '../types/LockArgs';
export type LockInstructionArgs = {
    lockArgs: LockArgs;
};
export declare const LockStruct: beet.FixableBeetArgsStruct<LockInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type LockInstructionAccounts = {
    authority: web3.PublicKey;
    tokenOwner?: web3.PublicKey;
    token: web3.PublicKey;
    mint: web3.PublicKey;
    metadata: web3.PublicKey;
    edition?: web3.PublicKey;
    tokenRecord?: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    sysvarInstructions: web3.PublicKey;
    splTokenProgram?: web3.PublicKey;
    authorizationRulesProgram?: web3.PublicKey;
    authorizationRules?: web3.PublicKey;
};
export declare const lockInstructionDiscriminator = 46;
export declare function createLockInstruction(accounts: LockInstructionAccounts, args: LockInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
