import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { MintArgs } from '../types/MintArgs';
export type MintInstructionArgs = {
    mintArgs: MintArgs;
};
export declare const MintStruct: beet.FixableBeetArgsStruct<MintInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type MintInstructionAccounts = {
    token: web3.PublicKey;
    tokenOwner?: web3.PublicKey;
    metadata: web3.PublicKey;
    masterEdition?: web3.PublicKey;
    tokenRecord?: web3.PublicKey;
    mint: web3.PublicKey;
    authority: web3.PublicKey;
    delegateRecord?: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    sysvarInstructions: web3.PublicKey;
    splTokenProgram: web3.PublicKey;
    splAtaProgram: web3.PublicKey;
    authorizationRulesProgram?: web3.PublicKey;
    authorizationRules?: web3.PublicKey;
};
export declare const mintInstructionDiscriminator = 43;
export declare function createMintInstruction(accounts: MintInstructionAccounts, args: MintInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
