import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { RevokeArgs } from '../types/RevokeArgs';
export type RevokeInstructionArgs = {
    revokeArgs: RevokeArgs;
};
export declare const RevokeStruct: beet.BeetArgsStruct<RevokeInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type RevokeInstructionAccounts = {
    delegateRecord?: web3.PublicKey;
    delegate: web3.PublicKey;
    metadata: web3.PublicKey;
    masterEdition?: web3.PublicKey;
    tokenRecord?: web3.PublicKey;
    mint: web3.PublicKey;
    token?: web3.PublicKey;
    authority: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    sysvarInstructions: web3.PublicKey;
    splTokenProgram?: web3.PublicKey;
    authorizationRulesProgram?: web3.PublicKey;
    authorizationRules?: web3.PublicKey;
};
export declare const revokeInstructionDiscriminator = 45;
export declare function createRevokeInstruction(accounts: RevokeInstructionAccounts, args: RevokeInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
