import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { TransferArgs } from '../types/TransferArgs';
export type TransferInstructionArgs = {
    transferArgs: TransferArgs;
};
export declare const TransferStruct: beet.FixableBeetArgsStruct<TransferInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type TransferInstructionAccounts = {
    token: web3.PublicKey;
    tokenOwner: web3.PublicKey;
    destination: web3.PublicKey;
    destinationOwner: web3.PublicKey;
    mint: web3.PublicKey;
    metadata: web3.PublicKey;
    edition?: web3.PublicKey;
    ownerTokenRecord?: web3.PublicKey;
    destinationTokenRecord?: web3.PublicKey;
    authority: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    sysvarInstructions: web3.PublicKey;
    splTokenProgram: web3.PublicKey;
    splAtaProgram: web3.PublicKey;
    authorizationRulesProgram?: web3.PublicKey;
    authorizationRules?: web3.PublicKey;
};
export declare const transferInstructionDiscriminator = 49;
export declare function createTransferInstruction(accounts: TransferInstructionAccounts, args: TransferInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
