import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { UnlockArgs } from '../types/UnlockArgs';
export type UnlockInstructionArgs = {
    unlockArgs: UnlockArgs;
};
export declare const UnlockStruct: beet.FixableBeetArgsStruct<UnlockInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type UnlockInstructionAccounts = {
    authority: web3.PublicKey;
    tokenOwner?: web3.PublicKey;
    token: web3.PublicKey;
    mint: web3.PublicKey;
    metadata: web3.PublicKey;
    edition?: web3.PublicKey;
    tokenRecord?: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    sysvarInstructions: web3.PublicKey;
    splTokenProgram?: web3.PublicKey;
    authorizationRulesProgram?: web3.PublicKey;
    authorizationRules?: web3.PublicKey;
};
export declare const unlockInstructionDiscriminator = 47;
export declare function createUnlockInstruction(accounts: UnlockInstructionAccounts, args: UnlockInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
