import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { UpdateArgs } from '../types/UpdateArgs';
export type UpdateInstructionArgs = {
    updateArgs: UpdateArgs;
};
export declare const UpdateStruct: beet.FixableBeetArgsStruct<UpdateInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type UpdateInstructionAccounts = {
    authority: web3.PublicKey;
    delegateRecord?: web3.PublicKey;
    token?: web3.PublicKey;
    mint: web3.PublicKey;
    metadata: web3.PublicKey;
    edition?: web3.PublicKey;
    payer: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    sysvarInstructions: web3.PublicKey;
    authorizationRulesProgram?: web3.PublicKey;
    authorizationRules?: web3.PublicKey;
};
export declare const updateInstructionDiscriminator = 50;
export declare function createUpdateInstruction(accounts: UpdateInstructionAccounts, args: UpdateInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
