import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { Creator } from './Creator';
import { TokenStandard } from './TokenStandard';
import { Collection } from './Collection';
import { Uses } from './Uses';
import { CollectionDetails } from './CollectionDetails';
export type AssetData = {
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: beet.COption<Creator[]>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    tokenStandard: TokenStandard;
    collection: beet.COption<Collection>;
    uses: beet.COption<Uses>;
    collectionDetails: beet.COption<CollectionDetails>;
    ruleSet: beet.COption<web3.PublicKey>;
};
export declare const assetDataBeet: beet.FixableBeetArgsStruct<AssetData>;
